package in.benchresources.normal.loan.approval.service;

import in.benchresources.entities.loan.ProcessLoanRequestType;
import in.benchresources.entities.loan.ProcessLoanResponseType;
import in.benchresources.services.hrmanagerloanapprovalservice.IHRManagerLoanApprovalService;

import javax.jws.WebService;

@WebService(serviceName="HRManagerLoanApprovalService", endpointInterface="in.benchresources.services.hrmanagerloanapprovalservice.IHRManagerLoanApprovalService",
targetNamespace="http://benchresources.in/services/HRManagerLoanApprovalService/", portName="HRManagerLoanApprovalServicePort", name="HRManagerLoanApprovalServiceImpl")
public class HRManagerLoanApprovalServiceImpl implements IHRManagerLoanApprovalService {

	// http://localhost:8080/EmployeeLoanService/services/HRManagerLoanApprovalService?wsdl - Apache Tomcat 7.x

	public ProcessLoanResponseType processEmployeeLoan(ProcessLoanRequestType parameters) {

		System.out.println("HRManagerLoanApprovalServiceImpl>>Id : " + ">>" + parameters.getEmployeeId() + "<<");
		System.out.println("HRManagerLoanApprovalServiceImpl>>Name : " + ">>" + parameters.getEmployeeName() + "<<");
		System.out.println("HRManagerLoanApprovalServiceImpl>>Grade : " + ">>" + parameters.getEmployeeGrade() + "<<");
		System.out.println("HRManagerLoanApprovalServiceImpl>>Amount : " + ">>" + parameters.getAmountInDollars() + "<<");
		System.out.println("HRManagerLoanApprovalServiceImpl>>Validated : " + ">>" + parameters.getEmployeeDetailValidated() + "<<");
		System.out.println("HRManagerLoanApprovalServiceImpl>>Comments : " + ">>" + parameters.getComments() + "<<");

		// create object response type and SET values based on the below "employeeDetailValidated" parameter
		ProcessLoanResponseType processLoanResponseType = null;

		if(null != parameters && "Yes".equalsIgnoreCase(parameters.getEmployeeDetailValidated().toString())) {

			System.out.println("HRManagerLoanApprovalServiceImpl>> Not null case");

			processLoanResponseType = new ProcessLoanResponseType();
			processLoanResponseType.setEmployeeId(parameters.getEmployeeId());
			processLoanResponseType.setEmployeeName(parameters.getEmployeeName());
			processLoanResponseType.setEmployeeGrade(parameters.getEmployeeGrade());
			processLoanResponseType.setAmountInDollars(parameters.getAmountInDollars());
			processLoanResponseType.setResponseMessage("Loan Approved for amount MORE than 4K dollars");
		}
		else {

			System.out.println("HRManagerLoanApprovalServiceImpl>> null case");

			processLoanResponseType = new ProcessLoanResponseType();
			processLoanResponseType.setEmployeeId(parameters.getEmployeeId());
			processLoanResponseType.setEmployeeName(parameters.getEmployeeName());
			processLoanResponseType.setEmployeeGrade(parameters.getEmployeeGrade());
			processLoanResponseType.setAmountInDollars(parameters.getAmountInDollars());
			processLoanResponseType.setResponseMessage("Loan Rejected: Employee details validation fails");
		}

		// finally return response type setting approval/rejection message with brief description
		return processLoanResponseType;
	}
}